Package org.bgerp.plugin.kernel

# Class Plugin

java.lang.Object
ru.bgcrm.plugin.Plugin
org.bgerp.plugin.kernel.Plugin

public class Plugin extends Plugin
Special plugin for application's kernel.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ENDPOINT_MESSAGE_EDITOR`
  `static final String`
  `ID`
  `static final Plugin`
  `INSTANCE`

  ### Fields inherited from class ru.bgcrm.plugin.Plugin

  `PATH_CSS, PATH_JS, PATH_JSP_ADMIN_PLUGIN, PATH_JSP_OPEN_PLUGIN, PATH_JSP_USER_PLUGIN, PATH_LIB`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected Map<String,List<String>>`
  `endpoints()`
  Plugin endpoints
  `Set<String>`
  `getActionPackages()`
  Packages for searching annotated actions.
  `Cleaner`
  `getCleaner()`
  DB cleaner.
  `Set<String>`
  `getObjectTypes()`
  Plugin's entities.
  `Set<Table>`
  `getTables()`
  Used DB tables.
  `void`
  `init(Connection con)`
  Initialization during server's start.
  `boolean`
  `isEnabled(ConfigMap config, String defaultValue)`
  If the plugin enabled.
  `boolean`
  `isSystem()`
  System plugins are always loaded, enabled and not show in the list.

  ### Methods inherited from class ru.bgcrm.plugin.Plugin

  `getDependencies, getEndpoints, getId, getLocalization, getLocalizer, getMessageTypeClass, getResourcePath, getTitle, getTitleWithPrefix, getXml, loadEndpoints`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### ID

    public static final String ID
    See Also:
      - Constant Field Values

  - ### INSTANCE

    public static final Plugin INSTANCE

  - ### ENDPOINT_MESSAGE_EDITOR

    public static final String ENDPOINT_MESSAGE_EDITOR
    See Also:
      - Constant Field Values

- ## Method Details

  - ### isSystem

    public boolean isSystem()
    Description copied from class: `Plugin`
    System plugins are always loaded, enabled and not show in the list.
    Overrides:
      `isSystem` in class `Plugin`
    Returns:

  - ### isEnabled

    public boolean isEnabled(ConfigMap config, String defaultValue)
    Description copied from class: `Plugin`
    If the plugin enabled.
    Overrides:
      `isEnabled` in class `Plugin`
    Parameters:
      `config` - configuration, where the plugin can be explicitly enabled.
      `defaultValue` - default value if not explicitly enabled: '1' - enabled, 'lic' - if presented in license.
    Returns:
      true or false.

  - ### getActionPackages

    public Set<String> getActionPackages()
    Description copied from class: `Plugin`
    Packages for searching annotated actions.
    Overrides:
      `getActionPackages` in class `Plugin`
    Returns:

  - ### getTables

    public Set<Table> getTables()
    Description copied from class: `Plugin`
    Used DB tables.
    Overrides:
      `getTables` in class `Plugin`
    Returns:

  - ### getObjectTypes

    public Set<String> getObjectTypes()
    Description copied from class: `Plugin`
    Plugin's entities.
    Overrides:
      `getObjectTypes` in class `Plugin`
    Returns:

  - ### getCleaner

    public Cleaner getCleaner()
    Description copied from class: `Plugin`
    DB cleaner.
    Overrides:
      `getCleaner` in class `Plugin`
    Returns:

  - ### endpoints

    protected Map<String,List<String>> endpoints()
    Description copied from class: `Plugin`
    Plugin endpoints
    Overrides:
      `endpoints` in class `Plugin`
    Returns:

  - ### init

    public void init(Connection con) throws Exception
    Description copied from class: `Plugin`
    Initialization during server's start.
    Overrides:
      `init` in class `Plugin`
    Parameters:
      `con` -
    Throws:
      `Exception`